using System;
class Sante
{
    static void Main()
    {
        string [] s=Console.ReadLine().Split();
        int n=int.Parse(s[0]);
        int m=int.Parse(s[1]);
        int[,] a=new int[m,4];
        int i,j,p=-1,z=-1,br=0;
        for(i=0; i<m; i++)
        {
            string [] sr=Console.ReadLine().Split();
            for(j=0; j<3; j++)
            {
                a[i,j]=int.Parse(sr[j]);
            }
        }
        string [] u=Console.ReadLine().Split();
        int k=int.Parse(u[0]);
        int l=int.Parse(u[1]);
        i=0;
        while(true)
        {
            for(j=0; j<2; j++)
            {
                if(a[i,j]==k)
                {
                    p=i;
                }
            }
            if(p!=-1)
            break;
            i++;
        }
        i=(m-1);
        while(true)
        {
            for(j=1; j>=0; j--)
            {
                if(a[i,j]==l)
                {
                    z=i;
                }
            }
            if(z!=-1)
            break;
            i--;
        }
        if(a[p,2]==1 && a[p+1,2]==1)
        {
            br++;
        }
        for(i=p; i<z; i++)
        {
            if(a[i,2]!=a[i+1,2])
            {
                br++;
            }
        }
        Console.WriteLine(br);
    }
}